var SELECTED_TAB_ID = "";
var SID = "";

var backEnabled = 0;
var forwardEnabled = 0;

window.onload = function() {
    addNewTab();
}

function addNewTab() {
    window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({action: "NavigateToNewTab"}));
}

function IncitoNavSearch(event) {
    if (event.keyCode === 13) {
        var searchField = document.getElementById("search-field");
        var searchText = searchField.value;
        
        if (searchText.length === 0) {
            return;
        }
        
        var url = "";
        var searchTerm;
        
        if (searchText.indexOf(".") > 0 && searchText.split(" ").length === 1) {
            if (searchText.indexOf("http://") === -1 && searchText.indexOf("https://") === -1) {
                url = "http://" + searchText;
            } else {
                url = searchText;
            }
        } else {
            searchTerm = encodeURIComponent(searchText);
            url = "https://cse.google.com/cse?cx=partner-pub-0820191131334362:3592241134&q=" + searchTerm + "&oq=" + searchTerm + "&gs_l=partner-generic.3...4463.5616.0.6158.0.0.0.0.0.0.0.0..0.0.gsnos%2Cn%3D13...0.1144j205182j8..1ac.1.25.partner-generic..0.0.0.#gsc.tab=0&gsc.q=" + searchTerm + "&gsc.page=1";
        }
        openUrl(url, searchTerm);
    }
}

function setURL(url) {
    var searchFieldElement = document.getElementById("search-field");
    
    if (url.toLowerCase().indexOf("file://") !== -1 ||
        url.toLowerCase().indexOf("red7studio.com") !== -1 ||
        url.toLowerCase().indexOf("red8.studio") !== -1 ||
        url.toLowerCase().indexOf("torvali") !== -1) {
        searchFieldElement.value = "";
        return;
    }
    
    if (url.toLowerCase().indexOf("incito.html") > 0) {
        searchFieldElement.value = "";
    } else {
        if(url.toLowerCase().indexOf("incitohome.html") > 0) {
            searchFieldElement.value = "";
        } else{
            searchFieldElement.value = url;
        }
    }
}

function unselectTabs() {
    var tabs = document.getElementsByClassName("tab");
    for (var i = 0; i < tabs.length; i++) {
        tabs[i].className = "tab";
    }
}

function addTab(tabLabel, tabId) {
    unselectTabs();
    
    document.getElementById("search-field").value = "";
    
    var tabElement = document.createElement("div");
    tabElement.id = tabId
    tabElement.className = "tab selected";
    tabElement.onclick = selectTab;
    
    var tabLabelElement = document.createElement("span");
    tabLabelElement.id = "tab-label-" + tabId;
    tabLabelElement.className = "label";
    tabLabelElement.innerHTML = tabLabel;
    
    var tabCloseElement = document.createElement("img");
    tabCloseElement.className = "close";
    tabCloseElement.src = "Exit.png";
    tabCloseElement.onclick = function (event) {
        event.stopPropagation();
        closeTabById(tabId);
    }
    
    var borderLeftElement = document.createElement("div");
    borderLeftElement.className = "border-left";
    
    var borderRightElement = document.createElement("div");
    borderRightElement.className = "border-right";
    
    tabElement.appendChild(tabLabelElement);
    tabElement.appendChild(tabCloseElement);
    tabElement.appendChild(borderLeftElement);
    tabElement.appendChild(borderRightElement);
    
    var tabs = document.getElementById("tabs");
    tabs.appendChild(tabElement);
    tabs.scrollLeft = tabs.scrollWidth;
    
    SELECTED_TAB_ID = tabId;
}

function selectTabById(tabId) {
    var clickedTab = document.getElementById(tabId);
    clickedTab.className = "tab selected";
    
    window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "ShowTab", tabId: tabId }));
    SELECTED_TAB_ID = tabId;
}

function selectTab() {
    unselectTabs();
    selectTabById(this.id);
}

function setCurrentTabLabel(tabLabel, tabId) {
    var currentTabLabel = document.getElementById("tab-label-" + tabId);
    if(tabLabel === "Welcome"){
        currentTabLabel.innerHTML = "Empire Global";
    }
    else{
        currentTabLabel.innerHTML = decodeURIComponent(tabLabel);
    }
}

function closeTabById(tabIdToClose) {
    var tabs = document.getElementsByClassName("tab");
    
    if (tabs.length === 1) {
        window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "CloseApplication" }));
    }
    
    for (var i = 0; i < tabs.length; i++) {
        var tabId = tabs[i].id;
        if (tabId === tabIdToClose) {
            if (tabId === SELECTED_TAB_ID) {
                if ((i + 1) < tabs.length) {
                    var selectedTabId = tabs[i + 1].id;
                    selectTabById(selectedTabId);
                } else if (i > 0) {
                    var selectedTabId = tabs[i - 1].id;
                    selectTabById(selectedTabId);
                }
            }
            
            window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "CloseTab", tabId: tabId }));
            
            tabs[i].remove();
            break;
        }
    }
    
    if (tabs.length === 1) {
        document.getElementById("search-field").value = "";
    }
}

function back() {
    if (backEnabled) {
        window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "Backward"}));
    }
    
}

function forward() {
    if (forwardEnabled) {
        window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "Forward"}));
    }
}

function refresh() {
    window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "Refresh"}));
}

function bookmarkCurrentPage() {
    var searchFieldValue = document.getElementById("search-field").value;
    
    if (searchFieldValue.length === 0) {
        return;
    }
    var replacedSearchFieldValue = searchFieldValue.replace("=", "--");
    
    openUrl("https://red8.studio/app?uid=e87747e8-3942-4a1f-bf04-64ae6130c86c&t=" + searchFieldValue + "&u=" + btoa(searchFieldValue));
}

function showBookmarks() {
    openUrl("https://red8.studio/app?uid=e87747e8-3942-4a1f-bf04-64ae6130c86c");
}

function openWallpaperApp() {
    openUrl("https://red8.studio/app?uid=fa7ca42e-fae5-438e-94b6-8833eaca95ec");
}

function openSettings() {
    openUrl("https://red8.studio/app?uid=ea50426c-9b45-4106-9846-1041e9435ba6");
}

function openUrl(url, searchTerm) {
    window.webkit.messageHandlers.PAINet.postMessage(JSON.stringify({ action: "NavigateTo", url: url, search: searchTerm }));
}

function toggleBackButton(canGoBack) {
    backEnabled = canGoBack;
    var backButton = document.getElementById("back-button");
    if (backEnabled) {
        backButton.classList.remove("disabled");
    } else {
        backButton.classList.add("disabled");
    }
}

function toggleForwardButton(canGoForward) {
    forwardEnabled = canGoForward;
    var forwardButton = document.getElementById("forward-button");
    if (forwardEnabled) {
        forwardButton.classList.remove("disabled");
    } else {
        forwardButton.classList.add("disabled");
    }
}

function PAIActionListener(data) {
    try {
        var _json = eval('(' + btoa(data) + ')');
        switch (_json.action.toLowerCase()) {
            case "setsid":
                SID = _json.sid;
            break;
        }
    } catch(err) {}
}
